<!DOCTYPE html>
<html lang="<?php language_attributes(); ?>">
  <head>
    <meta charset="<?php bloginfo( 'charset' ); ?>" />

    <!-- Always force latest IE rendering engine (even in intranet) & Chrome Frame
    Remove this if you use the .htaccess -->
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1" />

    <title><?php
  /*
   * Print the <title> tag based on what is being viewed.
   */
  global $page, $paged;

  wp_title( '|', true, 'right' );

  // Add the blog name.
  bloginfo( 'name' );

  // Add the blog description for the home/front page.
  $site_description = get_bloginfo( 'description', 'display' );
  if ( $site_description && ( is_home() || is_front_page() ) )
    echo " | $site_description";

  // Add a page number if necessary:
  if ( $paged >= 2 || $page >= 2 )
    echo ' | ' . sprintf( __( 'Page %s'), max( $paged, $page ) );

  ?></title>
    <meta name="description" content="" />
    <meta name="author" content="kim" />

    <meta name="viewport" content="width=device-width; initial-scale=1.0" />

    <!-- Replace favicon.ico & apple-touch-icon.png in the root of your domain and delete these references -->
    <link rel="shortcut icon" href="/favicon.ico" />
    <link rel="apple-touch-icon" href="/apple-touch-icon.png" />
    
    <link rel="stylesheet" href="<?php bloginfo( 'template_directory' ); ?>/assets/css/font-awesome.css">
    <link rel="stylesheet" href="<?php bloginfo( 'stylesheet_url' ); ?>" type="text/css" media="screen" title="no title" charset="utf-8"/>


  <!--[if lt IE 9]>
<script src="http://html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <link rel="stylesheet" href="<?php bloginfo( 'template_directory' ); ?>/assets/css/font-awesome-ie7.css">

<![endif]-->
<?php if ( is_singular() && get_option( 'thread_comments' ) )
    wp_enqueue_script( 'comment-reply' ); ?>

<?php wp_head(); ?>
  </head>
                    
  <body <?php body_class(); ?>>
    <div id="container">
      <div id="head-container">
        <header>
          <hgroup>
            <h1><a id="logo" title="<?php bloginfo('description'); ?>" href="<?php echo home_url(); ?>"><?php bloginfo('name'); ?></a></h1>
            <h2><?php bloginfo( 'description' ); ?></h2>
            
          </hgroup>
        </header>

      </div><!--close head-container-->
      <nav>
		    <?php wp_nav_menu(); ?>
      </nav>     
      
