<?php
/**
 * The Header for our theme.
 *
 * Displays all of the <head> section and everything up till <div id="main">
 *
 * @package WordPress
 * @subpackage Twenty_Eleven
 * @since Twenty Eleven 1.0
 */
?><!DOCTYPE html>
<!--[if IE 6]>
<html id="ie6" <?php language_attributes(); ?>>
<![endif]-->
<!--[if IE 7]>
<html id="ie7" <?php language_attributes(); ?>>
<![endif]-->
<!--[if IE 8]>
<html id="ie8" <?php language_attributes(); ?>>
<![endif]-->
<!--[if IE 10]>
<html id="ie10" <?php language_attributes(); ?>>
<![endif]-->
<!--[if !(IE 6) | !(IE 7) | !(IE 8)  ]><!-->
<html <?php language_attributes(); ?>>
<!--<![endif]-->
<head>
<meta charset="<?php bloginfo( 'charset' ); ?>" />
<meta name="viewport" content="width=device-width" />
<title><?php
	/*
	 * Print the <title> tag based on what is being viewed.
	 */
	global $page, $paged;

	wp_title( '|', true, 'right' );

	// Add the blog name.
	bloginfo( 'name' );

	// Add the blog description for the home/front page.
	$site_description = get_bloginfo( 'description', 'display' );
	if ( $site_description && ( is_home() || is_front_page() ) )
		echo " | $site_description";

	// Add a page number if necessary:
	if ( $paged >= 2 || $page >= 2 )
		echo ' | ' . sprintf( __( 'Page %s', 'twentyeleven' ), max( $paged, $page ) );

	?></title>
<link rel="profile" href="http://gmpg.org/xfn/11" />
<link href='http://api.mobilis.co.kr/webfonts/css/?fontface=NanumGothicWeb' rel='stylesheet' type='text/css' /> 
<link rel="stylesheet" type="text/css" media="all" href="<?php bloginfo( 'stylesheet_url' ); ?>" />
<link rel="pingback" href="<?php bloginfo( 'pingback_url' ); ?>" />
<!--[if lt IE 9]>
<script src="<?php echo get_template_directory_uri(); ?>/js/html5.js" type="text/javascript"></script>
<![endif]-->
<?php
	/* We add some JavaScript to pages with the comment form
	 * to support sites with threaded comments (when in use).
	 */
	if ( is_singular() && get_option( 'thread_comments' ) )
		wp_enqueue_script( 'comment-reply' );

	/* Always have wp_head() just before the closing </head>
	 * tag of your theme, or you will break many plugins, which
	 * generally use this hook to add elements to <head> such
	 * as styles, scripts, and meta tags.
	 */
	wp_head();
?>
</head>

<body <?php body_class(); ?>>
<div id="page" class="hfeed container">
  <div class="container"><div class="row">
<header id="branding" role="banner" class="span12">

			<hgroup>
				<h1 id="site-title"><span><a href="<?php echo esc_url( home_url( '/' ) ); ?>" title="<?php echo esc_attr( get_bloginfo( 'name', 'display' ) ); ?>" rel="home"><?php bloginfo( 'name' ); ?></a></span></h1>
				<h2 id="site-description"><?php bloginfo( 'description' ); ?></h2>
			</hgroup>
<?php $upload_dir = wp_upload_dir(); ?>
              <div id="myCarousel" class="carousel slide">
                <div class="carousel-inner">
                  <div class="item active">
                    <a href="index.php?p=229">
                    <img src="<?php echo $upload_dir['baseurl']; ?>/2012/08/copy-wheel.jpg" alt="">
                    <div class="carousel-caption">
                      <h4><?php echo get_the_title(229); ?></h4>
                      </a>
                    </div>
                  </div>
                  <div class="item">
                    <a href="index.php?cat=7">
                    <img src="<?php echo $upload_dir['baseurl']; ?>/2012/08/copy-lanterns.jpg" alt="">
                    <div class="carousel-caption">
                      <h4><?php echo get_cat_name(7);?></h4>
                      </a>
                    </div>
                  </div>
                  <div class="item">
                    <a href="index.php?cat=11">
                    <img src="<?php echo $upload_dir['baseurl']; ?>/2012/08/chessboard.jpg" alt="">
                    <div class="carousel-caption">
                      <h4><?php echo get_cat_name(11);?></h4>
                      </a>
                    </div>
                  </div>
                </div>
                <a class="left carousel-control" href="#myCarousel" data-slide="prev">&lsaquo;</a>
                <a class="right carousel-control" href="#myCarousel" data-slide="next">&rsaquo;</a>
              </div>			



        <nav id="access" role="navigation">
          <div class="navbar navbar-inverse">
            <div class="navbar-inner">
            <div class="container">
           
              <!-- 화면 폭이 줄어들었을 때 메뉴바를 함몰시키고 토글 버튼을 사용하여 메뉴 내용을 볼 수 있게 함-->
              <a class="btn btn-navbar" data-toggle="collapse" data-target=".nav-collapse">
              <span class="icon-bar"></span>
              <span class="icon-bar"></span>
              <span class="icon-bar"></span>
              </a>
           
              <!-- 블로그 이름을 나타나게하고 링크를 만들어줌 -->
              <a class="brand" href="<?php echo esc_url( home_url( '/' ) ); ?>" title="<?php echo esc_attr( get_bloginfo( 'name', 'display' ) ); ?>" rel="home"><?php bloginfo( 'name' ); ?></a>
           
              <!-- 실제 메뉴바의 내용이 들어감 화면 폭이 줄어들었을 때 함몰되는 부분임-->
              <div class="nav-collapse">
              <?php
             /** 메뉴바에 클래스 선택자와 아이디 선택자를 삽입 **/
              wp_nav_menu( array( 'walker' => new bootstrapwp_walker_nav_menu(), 'menu' => 'main-menu', 'menu_class' => 'nav', 'menu_id' => 'main-menu')); ?>
              <div class="navbar-search pull-right"><?php get_search_form(); ?></div>
              </div>
         
              </div>
            </div>
          </div>
        </nav><!-- #access -->
	</header><!-- #branding --></div></div>


	<div class="container wrapper">
    <div id="main" class="row">
